package com.alterdekim.game.controller.result.async;


import com.alterdekim.game.component.game.ClubAccessType;
import com.alterdekim.game.component.game.RoleFlags;
import com.alterdekim.game.xml.NumericBooleanSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonRootName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import jakarta.persistence.Column;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.Date;

@AllArgsConstructor
@NoArgsConstructor
@Getter
@Setter
@JsonRootName(value = "user")
public class UserResult {


    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "UserId")
    private Long id;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "Name")
    private String username;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "LocationServerName")
    private String locationServerName;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "RoleFlags")
    private RoleFlags roleFlags;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "InstructorLevel")
    private Integer instructorLevel;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "MagicLevel")
    private Integer magicLevel;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "RaceLevel")
    private Integer raceLevel;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "PhoneID")
    private Integer phoneID;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "BackgroundID")
    private Integer backgroundID;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "UsualTickets")
    private Integer usualTickets;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "MagicTickets")
    private Integer magicTickets;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "Experience")
    private Integer experience;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "Level")
    private Integer level;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "PositiveEnergy")
    private Integer positiveEnergy;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "VisaId")
    private Integer visaId;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "CurrentUseCount")
    private Integer currentUseCount;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "LastNewspaperId")
    private Integer lastNewspaperId;

    @JsonSerialize(using= NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "IsClubPresent")
    private Boolean isClubPresent;

    @JsonSerialize(using = NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "IsClubLocked")
    private Boolean isClubLocked;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "ClubAccessType")
    private ClubAccessType clubAccessType;

    @JsonSerialize(using= NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "IsMinorSecretAgent")
    private Boolean isMinorSecretAgent;

    @JsonSerialize(using= NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "HasSnFriends")
    private Boolean hasSnFriends;

    @JsonSerialize(using= NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "IsHomeLocked")
    private Boolean isHomeLocked;

    @JsonSerialize(using = NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "IsLimited")
    private Boolean isLimited;

    @JsonSerialize(using = NumericBooleanSerializer.class)
    @JacksonXmlProperty(isAttribute = true, localName = "IsOnline")
    private Boolean isOnline;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "CampId")
    private Integer campId;

    @Column(nullable = false)
    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "NiftTotalCount")
    private Integer niftTotalCount;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "DateRegistered")
    private Date dateRegistered;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "MinsLeft")
    private Integer minsLeft;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "TimesUsed")
    private Integer timesUsed;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true, localName = "IsFriend")
    private Boolean isFriend;
}
